//
//  UIViewController+JB_camera.m
//  聚宝物流
//
//  Created by Wzs 王 on 2017/10/25.
//  Copyright © 2017年 Wzs 王. All rights reserved.
//

#import "UIViewController+JB_camera.h"
#import "UIViewController+WXX_Alert.h"

#import<AVFoundation/AVCaptureDevice.h>
#import <AVFoundation/AVMediaFormat.h>
#import<AssetsLibrary/AssetsLibrary.h>
#import<CoreLocation/CoreLocation.h>

#import <objc/runtime.h>

@interface UIViewController ()<UIImagePickerControllerDelegate,UINavigationControllerDelegate>

@end


@implementation UIViewController (JB_camera)


- (UIImagePickerController *)wxxImgPickVC{
    
    UIImagePickerController *vc = objc_getAssociatedObject(self, @selector(wxxImgPickVC));
    if (vc == nil) {
        vc = [[UIImagePickerController alloc] init];
        
        [self setWxxImgPickVC:vc];
    }
    
    return vc;
}
- (void)setWxxImgPickVC:(UIImagePickerController *)wxxImgPickVC{
    
    objc_setAssociatedObject(self, @selector(wxxImgPickVC), wxxImgPickVC, OBJC_ASSOCIATION_RETAIN_NONATOMIC);
}

- (void)wxx_getPicFromePhotoList {
    [self getPicWithType:UIImagePickerControllerSourceTypeSavedPhotosAlbum];

}
- (void)wxx_getPic{
    
//    UIAlertController *
    
    [self sheetWithTitle:@"请选择" actionTitle1:@"从相册" handler1:^{
        [self getPicWithType:UIImagePickerControllerSourceTypeSavedPhotosAlbum];
    } actionTitle2:@"打开相机" handler2:^{
        [self getPicWithType:UIImagePickerControllerSourceTypeCamera];
        
    }];
    
    
}
#pragma mark---- 打开相机 或者相册 ----
- (void)getPicWithType:(UIImagePickerControllerSourceType)sourceType{
    
    if (sourceType == UIImagePickerControllerSourceTypeSavedPhotosAlbum) {//相册
       
        // 判断是否支持相册
        //相册权限
        ALAuthorizationStatus author = [ALAssetsLibrary authorizationStatus];
        if (author ==kCLAuthorizationStatusRestricted || author ==kCLAuthorizationStatusDenied){
            
            //无权限 引导去开启
            [self toSet];
            return;
        }
        
        
    }else if (sourceType == UIImagePickerControllerSourceTypeCamera){//相机
        
        //判断该设备是否支持调用相机或相册选取(模拟器不支持相机调用，所以直接调用会崩溃)
        if (![UIImagePickerController isSourceTypeAvailable:sourceType]) {
            
            [self alertWithTitle:@"模拟器不能用相机功能" actionTitle1:@"确定" handler1:^{
                
            } actionTitle2:nil handler2:nil];
            
            return;
        }
        
        // 判断是否支持相机
        //相机权限AVCaptureDevice
        AVAuthorizationStatus authStatus = [AVCaptureDevice authorizationStatusForMediaType:AVMediaTypeVideo];
        if (authStatus ==AVAuthorizationStatusRestricted ||//此应用程序没有被授权访问的照片数据。可能是家长控制权限
            authStatus ==AVAuthorizationStatusDenied)  //用户已经明确否认了这一照片数据的应用程序访问
        {
            [self toSet];
            return;
        }
            
       
    }
    
    __weak UIViewController *weakS = self;
    
    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(0 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
        UIImagePickerController *imagePickerController = [[UIImagePickerController alloc] init];
        imagePickerController.delegate = weakS;
//        imagePickerController.allowsEditing = YES;
        imagePickerController.sourceType = sourceType;
        [weakS presentViewController:imagePickerController animated:YES completion:^{
            
        }];
    });
    

}

#pragma mark---- 去设置 ----
- (void)toSet{
    
    [self alertWithTitle:@"没有权限..." actionTitle1:@"去开启" handler1:^{
        
        NSURL *url = [NSURL URLWithString:UIApplicationOpenSettingsURLString];
        if ([[UIApplication sharedApplication] canOpenURL:url]) {
            
            [[UIApplication sharedApplication] openURL:url];
            
        }

    } actionTitle2:nil handler2:nil];
   
}


#pragma mark---- 代理 ----
#pragma mark - UIImagePickerControllerDelegate
- (void)imagePickerController:(UIImagePickerController *)picker didFinishPickingMediaWithInfo:(NSDictionary *)info
{
    //原生图片
    UIImage *OriginalImage = [info objectForKey:UIImagePickerControllerOriginalImage];
    //修改过的图片
    UIImage *EditedImage = [info objectForKey:UIImagePickerControllerEditedImage];
    
    
    //缩放图片
    UIImage *imgScale = OriginalImage;
    //            = [self scaleFromImage: toSize:CGSizeMake(800.0f, 600.0f)];
    CGFloat quality = 0.1;
    NSData *imgData = UIImageJPEGRepresentation(imgScale, quality);
//    imgScale = [UIImage imageWithData:imgData];
    
    
    
    [picker dismissViewControllerAnimated:YES completion:nil];
    NSURL *pathUrl = info[@"UIImagePickerControllerImageURL"];
    NSString *path = pathUrl.absoluteString;
    [self wxx_getPicHandleWithOriginalImage:OriginalImage EditedImage:EditedImage saleImg_0_1_Data:imgData ImagePath:path];
    
}
- (void)imagePickerController:(UIImagePickerController *)picker didFinishPickingImage:(UIImage *)image editingInfo:(nullable NSDictionary<NSString *,id> *)editingInfo NS_DEPRECATED_IOS(2_0, 3_0){
  
    [picker dismissViewControllerAnimated:YES completion:nil];

}

-(void)imagePickerControllerDidCancel:(UIImagePickerController *)picker
{
    [picker dismissViewControllerAnimated:YES completion:nil];
}



- (void)wxx_getPicHandleWithOriginalImage:(UIImage *)OriginalImage EditedImage:(UIImage *)EditedImage saleImg_0_1_Data:(NSData *)imgData ImagePath:(NSString *)imagePath{
    
   
}





@end
